<?php


if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Af_Wc_Daps_Front' ) ) {

	class Af_Wc_Daps_Front {

		public function __construct() {

			
			$af_wc_daps_general_settings = (array) get_option( 'af_wc_daps_general_settings' );
			
			$af_wc_daps_enable_at_single_product_page     = isset( $af_wc_daps_general_settings['af_wc_daps_enable_at_single_product_page'] ) ? $af_wc_daps_general_settings['af_wc_daps_enable_at_single_product_page'] : '';
			$af_wc_daps_enable_at_checkout_page           = isset( $af_wc_daps_general_settings['af_wc_daps_enable_at_checkout_page'] ) ? $af_wc_daps_general_settings['af_wc_daps_enable_at_checkout_page'] : '';
			$af_wc_daps_delivery_info_field_position_hook = isset( $af_wc_daps_general_settings['af_wc_daps_delivery_info_field_position'] ) ? $af_wc_daps_general_settings['af_wc_daps_delivery_info_field_position'] : 'woocommerce_after_checkout_billing_form';
			

			add_action( 'wp_head', array( $this, 'af_wc_daps_custom_styles' ) );
			
			add_action( 'wp_enqueue_scripts', array( $this, 'af_wc_daps_enqueue_front_scripts' ) );
			
			if ( '' != $af_wc_daps_enable_at_single_product_page && '1' == $af_wc_daps_enable_at_single_product_page ) {
				
				add_action( 'woocommerce_before_add_to_cart_quantity', array( $this, 'af_wc_daps_delivery_info_form_on_single_product_page' ) );
				
				add_filter( 'woocommerce_add_cart_item_data', array( $this, 'af_wc_daps_save_delivery_info_data_to_cart_item' ), 10, 3 );
				
				add_filter( 'woocommerce_get_item_data', array( $this, 'af_wc_daps_display_delivery_info_data_in_cart' ), 10, 2 );
				
				add_filter( 'woocommerce_cart_calculate_fees', array( $this, 'af_wc_daps_add_fee_into_cart' ), 10, 1 );
				
				add_action( 'woocommerce_new_order_item', array( $this, 'af_wc_daps_add_delivery_info_data_to_order_for_individual_product' ), 10, 3 );
				
				add_action( 'woocommerce_order_item_meta_end', array( $this, 'af_wc_daps_display_delivery_info_data_to_order_for_individual_product' ), 10, 3 );
				
			}

			if ('1' == $af_wc_daps_enable_at_checkout_page ) {

				add_action( $af_wc_daps_delivery_info_field_position_hook, array( $this, 'af_wc_daps_display_delivery_info_form_on_checkout_page' ) );  

				add_action( 'woocommerce_checkout_create_order', array( $this, 'af_wc_daps_save_delivery_info_data_to_order_meta_data' ), 10, 2 );
				
				//store order meta data for checkout blocks

				add_action( 'woocommerce_store_api_checkout_update_order_meta', array( $this, 'af_wc_daps_save_delivery_info_data_to_order_meta_data_blocks' ), 10, 1 );

				add_action( 'woocommerce_before_calculate_totals', array( $this, 'af_wc_daps_calculate_order_fee_checkout_page' ) );

			}

			add_action( 'woocommerce_thankyou', array( $this, 'af_wc_daps_insert_order_delivery_info_table' ), 20, 1 );
			
			add_action( 'woocommerce_order_details_after_order_table', array( $this, 'af_wc_daps_display_delivery_info_data_for_whole_order' ) );

			add_filter( 'woocommerce_add_to_cart_validation', array( $this, 'af_wc_daps_add_to_cart_validation' ), 10, 5 );
			
			add_action('woocommerce_checkout_process', array( $this, 'af_wc_daps_place_order_validation' ));
			
			if ( function_exists( 'woocommerce_store_api_register_update_callback' ) ) {
				
				woocommerce_store_api_register_update_callback(
					array(
						'namespace' => 'extension-af-wc-daps-namespace',
						'callback'  => function ( $data ) {

							if (isset($data['date']) && $data['date'] && isset($data['timeSelectionType']) && $data['timeSelectionType'] && isset($data['timeSlot']) && $data['timeSlot'] && isset($data['ruleId']) && $data['ruleId'] && isset($data['dayFee']) && $data['dayFee']) {
								wc()->session->set('af_wc_daps_checkout_page_delivery_data', $data);
							}
						},
					)
				);
			}
		}

		public function af_wc_daps_custom_styles() {
			$af_wc_daps_calendar_style_settings = (array) get_option( 'af_wc_daps_calendar_style_settings' );

			$af_wc_daps_available_dates_background_color = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_available_dates_background_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_available_dates_background_color'] : '';
			$af_wc_daps_holiday_dates_background_color   = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_holiday_dates_background_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_holiday_dates_background_color'] : '';
			$af_wc_daps_special_dates_background_color   = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_special_dates_background_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_special_dates_background_color'] : '';
			$af_wc_daps_disabled_dates_background_color  = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_disabled_dates_background_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_disabled_dates_background_color'] : '';

			$af_wc_daps_available_dates_text_color = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_available_dates_text_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_available_dates_text_color'] : '';
			$af_wc_daps_holiday_dates_text_color   = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_holiday_dates_text_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_holiday_dates_text_color'] : '';
			$af_wc_daps_special_dates_text_color   = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_special_dates_text_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_special_dates_text_color'] : '';
			$af_wc_daps_disabled_dates_text_color  = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_disabled_dates_text_color'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_disabled_dates_text_color'] : '';

			echo '<style type="text/css">
		        .af_wc_daps_allowed_dates a {
		            background: ' . esc_attr( $af_wc_daps_available_dates_background_color ) . ' !important;
		            color: ' . esc_attr( $af_wc_daps_available_dates_text_color ) . ' !important;
		        }

		        .af_wc_daps_holidays span {
		            background: ' . esc_attr( $af_wc_daps_holiday_dates_background_color ) . ' !important;
		            color: ' . esc_attr( $af_wc_daps_holiday_dates_text_color ) . ' !important;
		        }

		        .af_wc_daps_special_date a {
		            background: ' . esc_attr( $af_wc_daps_special_dates_background_color ) . ' !important;
		            color: ' . esc_attr( $af_wc_daps_special_dates_text_color ) . ' !important;
		        }

		        .af_wc_daps_disabled_date span {
		            background: ' . esc_attr( $af_wc_daps_disabled_dates_background_color ) . ' !important;
		            color: ' . esc_attr( $af_wc_daps_disabled_dates_text_color ) . ' !important;
		        }
		    </style>';
		}

		public function af_wc_daps_add_fee_into_cart( $cart ) {

			$af_wc_daps_label_setting   = get_option('af_wc_daps_label_settings');
			$af_wc_daps_general_setting = get_option('af_wc_daps_general_settings');

			$af_wc_daps_delivery_fee_label = isset( $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label'] ) && '' != $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label']? $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label'] : 'Special Delivery Charges';
			$af_wc_daps_is_taxable         = isset( $af_wc_daps_general_setting['af_wc_daps_is_taxable'] ) ? true : false;


			$af_wc_daps_total_fee = 0;

			foreach ( $cart->get_cart() as $cart_item_key => $cart_item ) {
				$af_wc_daps_total_fee = $af_wc_daps_total_fee + ( floatval( isset( $cart_item['af_wc_daps_order_data']['af_wc_daps_rule_week_day_fee'] ) ? $cart_item['af_wc_daps_order_data']['af_wc_daps_rule_week_day_fee'] : 0 ) );
			}

			// @param string $name
			// @param float  $amount
			// @param bool   $taxable

			if ( 0 != $af_wc_daps_total_fee ) {
				$cart->add_fee( $af_wc_daps_delivery_fee_label, $af_wc_daps_total_fee, $af_wc_daps_is_taxable );
			}
		}

		public function af_wc_daps_calculate_order_fee_checkout_page( $cart ) {

			$af_wc_daps_label_setting   = get_option('af_wc_daps_label_settings');
			$af_wc_daps_general_setting = get_option('af_wc_daps_general_settings');

			$af_wc_daps_delivery_fee_label = isset( $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label'] ) && '' != $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label']? $af_wc_daps_label_setting['af_wc_daps_delivery_fee_label'] : 'Special Delivery Charges';
			$af_wc_daps_is_taxable         = isset( $af_wc_daps_general_setting['af_wc_daps_is_taxable'] ) ? true : false;

			if (!is_cart()) {
				$af_wc_daps_total_fee =0;

				if ( WC()->session->get( 'af_wc_daps_day_fee' ) != 0 || WC()->session->get( 'af_wc_daps_time_slot_fee' ) != 0 ) {
					$af_wc_daps_total_fee = floatval( WC()->session->get( 'af_wc_daps_day_fee' ) ) + floatval( WC()->session->get( 'af_wc_daps_time_slot_fee' ) );
					

				}

				foreach ( $cart->get_cart() as $cart_item_key => $cart_item ) {

					$af_wc_daps_total_fee = $af_wc_daps_total_fee + ( floatval( isset( $cart_item['af_wc_daps_order_data']['af_wc_daps_rule_week_day_fee'] ) ? $cart_item['af_wc_daps_order_data']['af_wc_daps_rule_week_day_fee'] : 0 ) );
				}
				
				if (0 != $af_wc_daps_total_fee) {
					$cart->add_fee( $af_wc_daps_delivery_fee_label, $af_wc_daps_total_fee, $af_wc_daps_is_taxable );
					// $cart->add_fee( $af_wc_daps_delivery_fee_label, $af_wc_daps_total_fee, true );

				}
			}
		}

		public function af_wc_daps_enqueue_front_scripts() {

			wp_enqueue_script( 'jquery' );
			wp_enqueue_script( 'jquery-ui-datepicker' );
			wp_enqueue_script( 'jquery-ui-core' );

			$af_wc_daps_calendar_style_settings = (array) get_option( 'af_wc_daps_calendar_style_settings' );
			$af_wc_daps_front_calendar_theme    = isset( $af_wc_daps_calendar_style_settings['af_wc_daps_front_calendar_theme'] ) ? $af_wc_daps_calendar_style_settings['af_wc_daps_front_calendar_theme'] : 'base';
			
			wp_enqueue_style( 'jquery-ui-theme', AF_WC_DAPS_PLUGIN_URL . '/assets/external-dependencies/jquery-ui-themes-1.14.1/themes/' . $af_wc_daps_front_calendar_theme . '/jquery-ui.css', array(), '1.14.1' );

			wp_enqueue_script( 'af-wc-daps-front-script', AF_WC_DAPS_PLUGIN_URL . 'assets/js/af-wc-daps-front-script.js', array( 'jquery' ), '1.0.0', true );

			wp_enqueue_style( 'af-wc-daps-front-style', AF_WC_DAPS_PLUGIN_URL . 'assets/css/af-wc-daps-front-style.css', array(), '1.0' );

			$af_wc_daps_holidays_settings     = af_wc_daps_get_all_holidays();
			$af_wc_daps_special_days_settings = af_wc_daps_get_remaining_orders_and_charges_of_all_sepecific_days();

			$af_wc_daps_label_settings = (array) get_option( 'af_wc_daps_label_settings' );
			
			$af_wc_daps_available_date_hover_text = isset( $af_wc_daps_label_settings['af_wc_daps_available_date_hover_text'] ) && '' != $af_wc_daps_label_settings['af_wc_daps_available_date_hover_text']? $af_wc_daps_label_settings['af_wc_daps_available_date_hover_text'] : 'Available Date';
			$af_wc_daps_special_date_hover_text   = isset( $af_wc_daps_label_settings['af_wc_daps_special_date_hover_text'] ) && '' != $af_wc_daps_label_settings['af_wc_daps_special_date_hover_text']? $af_wc_daps_label_settings['af_wc_daps_special_date_hover_text'] : 'Special Date';

			
			wp_localize_script(
				'af-wc-daps-front-script',
				'af_wc_daps_front_script_data',
				array(
					'ajax_url'                             => admin_url( 'admin-ajax.php' ),
					'af_wc_daps_nonce'                     => wp_create_nonce( 'af-wc-daps-ajax-nonce' ),
					'af_wc_daps_holidays_settings'         => $af_wc_daps_holidays_settings,
					'af_wc_daps_special_days_settings'     => $af_wc_daps_special_days_settings,
					'af_wc_daps_available_date_hover_text' => $af_wc_daps_available_date_hover_text,
					'af_wc_daps_special_date_hover_text'   => $af_wc_daps_special_date_hover_text,  
				)
			);
		}

		public function af_wc_daps_get_all_rules() {
			return get_posts(
				array(
					'post_type'      => 'daps_rules',
					'posts_per_page' => -1,
					'post_status'    => 'publish',
					'fields'         => 'ids',
					'orderby'        => 'menu_order',
					'order'          => 'DESC',
				)
			);
		}

		public function af_wc_daps_delivery_info_form_on_single_product_page() {

			global $post;
			$product_id = $post->ID;
			

			$child_ids_on_which_product_level_rule_applied = array();

			$product = wc_get_product( $product_id );

			if ($product->is_downloadable() || $product->is_virtual()) {
				return;
			}

			$af_wc_daps_rule_settings = (array) get_post_meta( $product_id, 'af_wc_daps_rule_settings', true );

			//return if no rule is created and also no product level rule is activated
			if ( $product->is_type( 'variable' ) ) {
				$matched                 = false;
				$af_wc_daps_children_ids = $product->get_children();
				foreach ( $af_wc_daps_children_ids as $child_id ) {
					$af_wc_daps_rule_settings = (array) get_post_meta( $child_id, 'af_wc_daps_rule_settings', true );

					if ( isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {
						$matched = true;
						break;
					}
				}

				if (empty($this->af_wc_daps_get_all_rules()) && !$matched) {
					return;
				}

			} elseif (empty($this->af_wc_daps_get_all_rules())  && ( !isset($af_wc_daps_rule_settings['af_wc_daps_enable_rule']) || 'yes' != $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] )) {
					return;

			}

			if ( $product->is_type( 'variable' ) ) {
				
				$af_wc_daps_children_ids = $product->get_children();
				$af_wc_daps_rule_applied = false;

				foreach ( $af_wc_daps_children_ids as $child_id ) {

					$af_wc_daps_proudct_id_with_rule = '';

					$af_wc_daps_rule_settings = (array) get_post_meta( $child_id, 'af_wc_daps_rule_settings', true );

					if ( ! empty( $af_wc_daps_rule_settings ) && isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {

						if ( 'expected_date' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
							$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
							$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
							$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] : '';
							af_wc_daps_expected_date_info( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days, $child_id, $af_wc_daps_rule_expected_date_message_text );
							$child_ids_on_which_product_level_rule_applied[] = $child_id;
							$af_wc_daps_rule_applied                         = true;
						} elseif ('calendar' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode']) {

							$child_ids_on_which_product_level_rule_applied[] = $child_id;

							$af_wc_daps_rule_applied = true;

							$af_wc_daps_proudct_id_with_rule = $child_id;

							$af_wc_daps_rule_settings['af_wc_daps_product_id'] = $child_id;

							wp_localize_script(
								'af-wc-daps-front-script',
								'af_wc_daps_product_level_rule_settings_' . $child_id,
								$af_wc_daps_rule_settings
							);
							af_wc_daps_delivery_info_table( $af_wc_daps_proudct_id_with_rule, $af_wc_daps_rule_settings, $child_id );
						}
					}
				}
			}

			$af_wc_daps_proudct_id_with_rule = '';

			$af_wc_daps_rule_settings = (array) get_post_meta( $product_id, 'af_wc_daps_rule_settings', true );

			if ( ! empty( $af_wc_daps_rule_settings ) && isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {
				if ( 'expected_date' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
					$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
					$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
					$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] : '';
					af_wc_daps_expected_date_info( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days, $product_id, $af_wc_daps_rule_expected_date_message_text );
					return;
				}

				$af_wc_daps_proudct_id_with_rule = $product_id;

				$af_wc_daps_rule_settings['af_wc_daps_product_id'] = $product_id;

				wp_localize_script(
					'af-wc-daps-front-script',
					'af_wc_daps_product_level_rule_settings_' . $product_id,
					$af_wc_daps_rule_settings
				);

				af_wc_daps_delivery_info_table( $af_wc_daps_proudct_id_with_rule, $af_wc_daps_rule_settings , $product_id);

				return;

			}

			$af_wc_daps_rule_posts = $this->af_wc_daps_get_all_rules();

			foreach ( $af_wc_daps_rule_posts as $post_id ) {
				if ( empty( $post_id ) ) {
					continue;
				}

				$is_product_match = false;

				$af_wc_daps_post_level_settings = (array) get_post_meta( $post_id, 'af_wc_daps_rule_settings', true );


				if ( empty( $af_wc_daps_post_level_settings ) ) {
					continue;
				}

				if ( ! isset( $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) || 'yes' != $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) {
					continue;
				}

				$af_wc_daps_product_ids_for_rule  = isset( $af_wc_daps_post_level_settings['af_wc_daps_product_ids_for_rule'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_product_ids_for_rule'] : array();
				$af_wc_daps_selected_category_ids = isset( $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] ) ? $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] : array();

				$product_categories = wp_get_post_terms( $product_id, 'product_cat', array( 'fields' => 'ids' ) );

				if ( $product->is_type( 'variable' ) ) {

					$af_wc_daps_children_ids = $product->get_children();

					foreach ( $af_wc_daps_children_ids as $child_id ) {

						//rule applied on this product at this variation of variable product at product level
						if (in_array($child_id, $child_ids_on_which_product_level_rule_applied)) {
							continue;
						}

						$is_product_match = false;

						if ( empty( $af_wc_daps_product_ids_for_rule ) && empty( $af_wc_daps_selected_category_ids ) ) {
							$is_product_match = true;
						} elseif ( ! empty( $af_wc_daps_product_ids_for_rule ) && in_array( $child_id, $af_wc_daps_product_ids_for_rule ) ) {
							$is_product_match = true;
						} elseif ( ! empty( $af_wc_daps_selected_category_ids ) && ! empty( array_intersect( $product_categories, $af_wc_daps_selected_category_ids ) ) ) {
							$is_product_match = true;
						}

						if ( $is_product_match ) {

							if ( 'expected_date' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
								$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
								$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
								$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] : '';
								af_wc_daps_expected_date_info( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days, $child_id, $af_wc_daps_rule_expected_date_message_text );
								$child_ids_on_which_product_level_rule_applied[] = $child_id;
							} elseif ('calendar' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode'] ) {

								$child_ids_on_which_product_level_rule_applied[] = $child_id;
								$af_wc_daps_proudct_id_with_rule                 = $child_id;

								$af_wc_daps_post_level_settings['af_wc_daps_product_id'] = $child_id;

								wp_localize_script(
									'af-wc-daps-front-script',
									'af_wc_daps_product_level_rule_settings_' . $child_id,
									$af_wc_daps_post_level_settings
								);

								af_wc_daps_delivery_info_table( $af_wc_daps_proudct_id_with_rule, $af_wc_daps_post_level_settings, $post_id );
							}

							

						}
					}
					// return;
				}

				if ( empty( $af_wc_daps_product_ids_for_rule ) && empty( $af_wc_daps_selected_category_ids ) ) {
					$is_product_match = true;
				} elseif ( ! empty( $af_wc_daps_product_ids_for_rule ) && in_array( $product_id, $af_wc_daps_product_ids_for_rule ) ) {
					$is_product_match = true;
				} elseif ( ! empty( $af_wc_daps_selected_category_ids ) && ! empty( array_intersect( $product_categories, $af_wc_daps_selected_category_ids ) ) ) {
					$is_product_match = true;
				}

				if ( $is_product_match ) {

					if ( 'expected_date' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
						$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
						$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
						$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] : '';
						af_wc_daps_expected_date_info( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days, $product_id, $af_wc_daps_rule_expected_date_message_text );
						return;
					} elseif ('calendar' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode']) {
						$af_wc_daps_proudct_id_with_rule = $product_id;

						$af_wc_daps_post_level_settings['af_wc_daps_product_id'] = $product_id;

						wp_localize_script(
							'af-wc-daps-front-script',
							'af_wc_daps_product_level_rule_settings_' . $product_id,
							$af_wc_daps_post_level_settings
						);

						af_wc_daps_delivery_info_table( $af_wc_daps_proudct_id_with_rule, $af_wc_daps_post_level_settings, $post_id );
						return;

					}

					
					// return;
				}
			}
		}

		public function af_wc_daps_save_delivery_info_data_to_cart_item( $cart_item_data, $product_id, $variation_id ) {

			$nonce                           = isset( $_POST['af_wc_daps_nonce_field'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_nonce_field'] ) ) : '';
			$af_wc_daps_special_days_setting = af_wc_daps_get_remaining_orders_and_charges_of_all_sepecific_days();

			if ( isset( $_POST['af_wc_daps_nonce_field'] ) && ! wp_verify_nonce( $nonce, 'af_wc_daps_nonce' ) ) {
				return $cart_item_data;
			}

			$af_wc_daps_product_id = $product_id;

			if ( 0 != $variation_id ) {
				$af_wc_daps_product_id = $variation_id;
			}
			if ( isset( $_POST[ 'af_wc_daps_proudct_id_with_rule_' . $af_wc_daps_product_id ] ) && ! $af_wc_daps_product_id == $_POST[ 'af_wc_daps_proudct_id_with_rule_' . $af_wc_daps_product_id ] ) {
				return $cart_item_data;
			}
			if ( isset( $_POST[ 'af_wc_daps_expected_date_info_field_' . $af_wc_daps_product_id ] ) ) {

				$af_wc_daps_expected_date_info              = sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_expected_date_info_field_' . $af_wc_daps_product_id ] ) );
				$cart_item_data['af_wc_daps_expected_date'] = array(
					'af_wc_daps_expected_date_info' => $af_wc_daps_expected_date_info,
				);
				return $cart_item_data;
			}

			if ( isset( $_POST[ 'af_wc_daps_single_product_page_enable_' . $af_wc_daps_product_id ] ) || isset( $_POST[ 'af_wc_daps_single_product_page_date_' . $af_wc_daps_product_id ] ) || isset( $_POST[ 'af_wc_daps_time_for_single_product_' . $af_wc_daps_product_id ] ) || isset( $_POST[ 'af_wc_daps_time_slot_select_' . $af_wc_daps_product_id ] ) ) {

				$af_wc_daps_rule_id                    = isset( $_POST[ 'af_wc_daps_rule_id_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_rule_id_' . $af_wc_daps_product_id ] ) ) : '';
				$af_wc_daps_single_product_page_enable = isset( $_POST[ 'af_wc_daps_single_product_page_enable_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_single_product_page_enable_' . $af_wc_daps_product_id ] ) ) : '';
				$af_wc_daps_single_product_page_date   = isset( $_POST[ 'af_wc_daps_single_product_page_date_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_single_product_page_date_' . $af_wc_daps_product_id ] ) ) : '';

				$af_wc_daps_time_for_single_product = isset( $_POST[ 'af_wc_daps_time_for_single_product_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_time_for_single_product_' . $af_wc_daps_product_id ] ) ) : '';

				if ('' != $af_wc_daps_time_for_single_product) {
					$af_wc_daps_time_for_single_product = explode('_', $af_wc_daps_time_for_single_product);
	
					$timeslot_key                       = $af_wc_daps_time_for_single_product[0];
					$af_wc_daps_time_for_single_product = $af_wc_daps_time_for_single_product[1];

				}

				$af_wc_daps_time_slot_select = isset( $_POST[ 'af_wc_daps_time_slot_select_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_time_slot_select_' . $af_wc_daps_product_id ] ) ) : '';

				if ('' != $af_wc_daps_time_slot_select) {
					$af_wc_daps_time_slot_select = explode('_', $af_wc_daps_time_slot_select);
	
					$timeslot_key                = $af_wc_daps_time_slot_select[0];
					$af_wc_daps_time_slot_select = $af_wc_daps_time_slot_select[1];

				}

				$af_wc_daps_rule_week_day_fee = isset( $_POST[ 'af_wc_daps_week_day_fee_' . $af_wc_daps_product_id ] ) ? sanitize_text_field( wp_unslash( $_POST[ 'af_wc_daps_week_day_fee_' . $af_wc_daps_product_id ] ) ) : '';

				$af_wc_daps_selected_day_fee = 0;
				$af_wc_daps_only_day_fee     = 0;
				

				if ( '' != $af_wc_daps_single_product_page_date ) {

					foreach ($af_wc_daps_special_days_setting as  $specific_day) {
						if ($specific_day['af_wc_daps_date']) {
							if ($specific_day['af_wc_daps_date'] == $af_wc_daps_single_product_page_date) {
								$af_wc_daps_selected_day_fee = $af_wc_daps_selected_day_fee + isset($specific_day['af_wc_daps_specific_day_charges'])?$specific_day['af_wc_daps_specific_day_charges']:0;
								break;
							}
						}
					}

					$af_wc_daps_time_stamp = strtotime( $af_wc_daps_single_product_page_date );

					$af_wc_daps_day_name = gmdate( 'l', $af_wc_daps_time_stamp );

					$af_wc_daps_day_map = array(
						'Monday'    => 0,
						'Tuesday'   => 1,
						'Wednesday' => 2,
						'Thursday'  => 3,
						'Friday'    => 4,
						'Saturday'  => 5,
						'Sunday'    => 6,
					);

					$af_wc_daps_day_number = $af_wc_daps_day_map[ $af_wc_daps_day_name ];

					$af_wc_daps_values = explode( ',', $af_wc_daps_rule_week_day_fee );

					$af_wc_daps_only_day_fee = floatval($af_wc_daps_selected_day_fee);

					if ( isset( $af_wc_daps_values[ $af_wc_daps_day_number ] ) ) {
						$af_wc_daps_selected_day_fee = floatval($af_wc_daps_selected_day_fee) + floatval($af_wc_daps_values[ $af_wc_daps_day_number ]);
						$af_wc_daps_only_day_fee     = $af_wc_daps_selected_day_fee; 

					}

					if ( '' != $af_wc_daps_time_for_single_product ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_selected_day_fee + af_wc_daps_extract_time_slot_fee( $af_wc_daps_time_for_single_product );

					}

					if ( '' != $af_wc_daps_time_slot_select ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_selected_day_fee + af_wc_daps_extract_time_slot_fee( $af_wc_daps_time_slot_select );

					}
				}

				$applied_time_slot_details = '';
				if ('' != $af_wc_daps_time_slot_select) {
					$applied_time_slot_details = $af_wc_daps_rule_id . '_' . $timeslot_key;
				}

				if ('' != $af_wc_daps_time_for_single_product) {
					$applied_time_slot_details = $af_wc_daps_rule_id . '_' . $timeslot_key;
				}

				$cart_item_data['af_wc_daps_order_data'] = array(
					'af_wc_daps_single_product_page_enable' => $af_wc_daps_single_product_page_enable,
					'af_wc_daps_single_product_page_date' => $af_wc_daps_single_product_page_date,
					'af_wc_daps_time_for_single_product'  => $af_wc_daps_time_for_single_product,
					'af_wc_daps_time_slot_select'         => $af_wc_daps_time_slot_select,
					'af_wc_daps_only_day_fee'             => $af_wc_daps_only_day_fee,
					'af_wc_daps_rule_week_day_fee'        => $af_wc_daps_selected_day_fee,
					'applied_time_slot_details'           => $applied_time_slot_details,
				);
			}
			return $cart_item_data;
		}

		public function af_wc_daps_display_delivery_info_data_in_cart( $item_data, $cart_item ) {

			if ( isset( $cart_item['af_wc_daps_order_data'] ) && is_array( $cart_item['af_wc_daps_order_data'] ) ) {
				$order_data = $cart_item['af_wc_daps_order_data'];

				foreach ( $order_data as $key => $value ) {
					$key = af_wc_daps_formatted_key_names( $key );

					if ('af_wc_daps_single_product_page_enable' == $key || 'applied_time_slot_details' == $key) {
						continue;
					}

					if ( ( 'Total Fee' == $key || 'Day Fee' == $key ) && 0 == $value ) {
						continue;
					}

					if ( '' != $value ) {
						if ('Total Fee' == $key || 'Day Fee' == $key) {
							$item_data[] = array(
								'key'   => $key,
								'value' =>   wp_kses_post( wc_price($value) ),
							);
						} else {
							$item_data[] = array(
								'key'   => $key,
								'value' => $value,
							);
						}
						
					}
				}
			}

			if ( isset( $cart_item['af_wc_daps_expected_date'] ) && is_array( $cart_item['af_wc_daps_expected_date'] ) ) {
				$item_data[] = array(
					'key'   => 'Expected Date',
					'value' => $cart_item['af_wc_daps_expected_date']['af_wc_daps_expected_date_info'],
				);
			}
			return $item_data;
		}

		public function af_wc_daps_add_delivery_info_data_to_order_for_individual_product( $item_id, $item, $item_order_id ) {

			if ($item->legacy_values && isset($item->legacy_values['af_wc_daps_order_data']) && !empty($item->legacy_values['af_wc_daps_order_data'])) {
				$order_data = $item->legacy_values['af_wc_daps_order_data'];
				wc_add_order_item_meta( $item_id, 'af_wc_daps_delivery_info_data', $order_data );
			}

			if ($item->legacy_values && isset($item->legacy_values['af_wc_daps_expected_date']) && !empty($item->legacy_values['af_wc_daps_expected_date'])) {
				$order_data = $item->legacy_values['af_wc_daps_expected_date'];
				wc_add_order_item_meta( $item_id, 'af_wc_daps_expected_date_data', $order_data );
			}
		}

		public function af_wc_daps_display_delivery_info_data_to_order_for_individual_product( $item_id, $item, $order ) {

			$af_wc_daps_delivery_info_data = (array) wc_get_order_item_meta( $item_id, 'af_wc_daps_delivery_info_data', true );
			$af_wc_daps_expected_date_data = (array) wc_get_order_item_meta( $item_id, 'af_wc_daps_expected_date_data', true );

			if ( ! empty( $af_wc_daps_delivery_info_data ) ) {

				foreach ( $af_wc_daps_delivery_info_data as $key => $value ) {

					$key = af_wc_daps_formatted_key_names( $key );

					if ('af_wc_daps_single_product_page_enable' == $key || 'applied_time_slot_details' == $key) {
						continue;
					}

					if ( ( 'Total Fee' == $key || 'Day Fee' == $key ) && 0 == $value ) {
						continue;
					}
					if ( '' != $value ) {
						if ('Total Fee' == $key || 'Day Fee' == $key) {
							echo '<br>';
							echo esc_attr( $key ) . ' : ' . wp_kses_post( wc_price($value) );
							continue;
						}
						echo '<br>';
						echo esc_attr( $key ) . ' : ' . esc_attr( $value );
					}
				}
			}

			if ( ! empty( $af_wc_daps_expected_date_data ) ) {
				foreach ( $af_wc_daps_expected_date_data as $key => $value ) {
					if ( '' == $value ) {
						continue;
					}
					echo '<br>';
					echo 'Expected Date : ' . esc_attr( $value );
				}
			}
		}

		public function af_wc_daps_display_delivery_info_form_on_checkout_page( $checkout ) {

			global $woocommerce;

			$af_wc_daps_found_product_without_meta = false;

			$af_wc_daps_products_in_cart_on_which_rule_not_applied = array();

			//return if no rule and no product level setting is activated
			$matched = false;
			foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $cart_item ) {
				if ($cart_item['product_id']) {
					$af_wc_daps_rule_settings = (array) get_post_meta( $cart_item['product_id'], 'af_wc_daps_rule_settings', true );

					if ( isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {
						$matched = true;
						break;
					}

				}
			}

			if (empty($this->af_wc_daps_get_all_rules()) && !$matched) {
				return;
			}



			foreach ( $woocommerce->cart->get_cart() as $cart_item_key => $cart_item ) {

				$af_wc_daps_product_delivery_date = isset( $cart_item['af_wc_daps_order_data']['af_wc_daps_single_product_page_date'] ) ? $cart_item['af_wc_daps_order_data']['af_wc_daps_single_product_page_date'] : '';
				$af_wc_daps_product_expected_date = isset( $cart_item['af_wc_daps_expected_date']['af_wc_daps_expected_date_info'] ) ? $cart_item['af_wc_daps_expected_date']['af_wc_daps_expected_date_info'] : '';

				if ( '' == $af_wc_daps_product_delivery_date && '' == $af_wc_daps_product_expected_date ) {

					$af_wc_daps_product_id = $cart_item['product_id'];

					if ( 0 != $cart_item['variation_id'] ) {
						$af_wc_daps_product_id = $cart_item['variation_id'];
					}

					$product = wc_get_product($af_wc_daps_product_id);

					//if product is virtual/downloadable skip it.
					if ($product->is_downloadable() || $product->is_virtual()) {
						continue;
					}

					$af_wc_daps_products_in_cart_on_which_rule_not_applied[] = $af_wc_daps_product_id;
					$af_wc_daps_found_product_without_meta                   = true;
				}
			}

			
			//apply the rule of that product which has the late date among other product
			$af_wc_daps_largest_minimum_days                      = 0; 
			$af_wc_daps_product_whose_rule_found_on_product_level = array();
			$af_wc_daps_product_id_with_largest_value             = isset($af_wc_daps_products_in_cart_on_which_rule_not_applied[0])?$af_wc_daps_products_in_cart_on_which_rule_not_applied[0]:'';

			foreach ($af_wc_daps_products_in_cart_on_which_rule_not_applied as $product_id) {
				$af_wc_daps_rule_settings = (array) get_post_meta($product_id, 'af_wc_daps_rule_settings', true);
		
				if ( empty( $af_wc_daps_rule_settings ) || !isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) ||  '' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {
					continue;
				}

				if ('calendar' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode']) {
					$af_wc_daps_minimum_days                                = isset($af_wc_daps_rule_settings['af_wc_daps_rule_min_available_days']) ? $af_wc_daps_rule_settings['af_wc_daps_rule_min_available_days'] : 1;
					$af_wc_daps_product_whose_rule_found_on_product_level[] =$product_id;
				} else {
					$af_wc_daps_minimum_days                                = isset($af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days']) && '' != $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] ? $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] : 1;
					$af_wc_daps_product_whose_rule_found_on_product_level[] =$product_id;
				}

				if ($af_wc_daps_minimum_days > $af_wc_daps_largest_minimum_days) {
					$af_wc_daps_largest_minimum_days          = $af_wc_daps_minimum_days;
					$af_wc_daps_product_id_with_largest_value = $product_id;
				}
			}
			

			$af_wc_daps_rule_posts = $this->af_wc_daps_get_all_rules();
			$product_categories    = af_wc_daps_get_all_categories_for_product_ids_array( $af_wc_daps_products_in_cart_on_which_rule_not_applied );

			$af_wc_daps_largest_minimum_days_rule_level = 0; 
			$af_wc_daps_rule_id_with_largest_value      = null;
			
			if ($af_wc_daps_found_product_without_meta) {
				foreach ($af_wc_daps_products_in_cart_on_which_rule_not_applied as $product_id) {

					

					foreach ($af_wc_daps_rule_posts as $rule_id) {
						$is_product_match =false;
						if ( empty( $rule_id ) ) {
							continue;
						}
						if (in_array($product_id, $af_wc_daps_product_whose_rule_found_on_product_level)) {
							continue;
						}


						$af_wc_daps_post_level_settings   = (array) get_post_meta( $rule_id, 'af_wc_daps_rule_settings', true );
						$af_wc_daps_product_ids_for_rule  = isset( $af_wc_daps_post_level_settings['af_wc_daps_selected_product_ids'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_selected_product_ids'] : array();
						$af_wc_daps_selected_category_ids = isset( $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] ) ? $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] : array();

						if ( empty( $af_wc_daps_post_level_settings ) || !isset( $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) ||  '' == $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) {
							continue;
						}
						

						if ( empty( $af_wc_daps_product_ids_for_rule ) && empty( $af_wc_daps_selected_category_ids ) ) {
							$is_product_match = true;
						} elseif ( ! empty( $af_wc_daps_product_ids_for_rule ) && in_array( $product_id, $af_wc_daps_product_ids_for_rule ) ) {
							$is_product_match = true;
						} elseif ( ! empty( $af_wc_daps_selected_category_ids ) && ! empty( array_intersect( $product_categories, $af_wc_daps_selected_category_ids ) ) ) {
							$is_product_match = true;
						}

						if ($is_product_match) {
							if ('calendar' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode']) {
								$af_wc_daps_minimum_days                                = isset($af_wc_daps_post_level_settings['af_wc_daps_rule_min_available_days']) && ''!=$af_wc_daps_post_level_settings['af_wc_daps_rule_min_available_days'] ? $af_wc_daps_post_level_settings['af_wc_daps_rule_min_available_days'] : 1;
								$af_wc_daps_product_whose_rule_found_on_product_level[] =$product_id;
							} else {
								$af_wc_daps_minimum_days                                = isset($af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days']) &&  '' != $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days']? $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] : 1;
								$af_wc_daps_product_whose_rule_found_on_product_level[] =$product_id;
							}
							
							if ($af_wc_daps_minimum_days > $af_wc_daps_largest_minimum_days_rule_level) {
								$af_wc_daps_largest_minimum_days_rule_level = $af_wc_daps_minimum_days;
								$af_wc_daps_rule_id_with_largest_value      = $rule_id;
							}
						}

					}
				}
			}
			
			
			if ($af_wc_daps_product_id_with_largest_value && $af_wc_daps_largest_minimum_days >= $af_wc_daps_largest_minimum_days_rule_level) {
				$af_wc_daps_rule_settings = (array) get_post_meta( $af_wc_daps_product_id_with_largest_value, 'af_wc_daps_rule_settings', true );

				if ( ! empty( $af_wc_daps_rule_settings ) && isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {

					if ( isset( $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode'] ) && 'expected_date' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
						$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
						$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
						$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_rule_settings['af_wc_daps_rule_expected_date_message_text'] : '';
						af_wc_daps_expected_date_info_checkout_page( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days , $af_wc_daps_rule_expected_date_message_text );
						return;
					}

					wp_localize_script(
						'af-wc-daps-front-script',
						'af_wc_daps_checkout_page_rule_settings',
						$af_wc_daps_rule_settings
					);
					af_wc_daps_delivery_info_table_checkout_page( $af_wc_daps_rule_settings, $af_wc_daps_product_id_with_largest_value);

					return;
				}
			} elseif ($af_wc_daps_rule_id_with_largest_value && $af_wc_daps_largest_minimum_days_rule_level >= $af_wc_daps_largest_minimum_days) {
				$af_wc_daps_post_level_settings = (array) get_post_meta( $af_wc_daps_rule_id_with_largest_value, 'af_wc_daps_rule_settings', true );
				if ( 'expected_date' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
					$af_wc_daps_rule_minimum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_minimum_delivery_days'] : '';
					$af_wc_daps_rule_maximum_delivery_days      = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_maximum_delivery_days'] : '';
					$af_wc_daps_rule_expected_date_message_text = isset( $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_rule_expected_date_message_text'] : '';
					af_wc_daps_expected_date_info_checkout_page( $af_wc_daps_rule_minimum_delivery_days, $af_wc_daps_rule_maximum_delivery_days , $af_wc_daps_rule_expected_date_message_text );
					return;
				}

				wp_localize_script(
					'af-wc-daps-front-script',
					'af_wc_daps_checkout_page_rule_settings',
					$af_wc_daps_post_level_settings
				);
				af_wc_daps_delivery_info_table_checkout_page( $af_wc_daps_post_level_settings, $af_wc_daps_rule_id_with_largest_value);

				return;

			}
		}

		public function af_wc_daps_save_delivery_info_data_to_order_meta_data( $order, $data ) {

			$nonce = isset( $_POST['af_wc_daps_nonce_field'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_nonce_field'] ) ) : '';

			if ( isset( $_POST['af_wc_daps_nonce_field'] ) && ! wp_verify_nonce( $nonce, 'af_wc_daps_nonce' ) ) {
				return;
			}


			if ( isset( $_POST['af_wc_daps_expected_date_info_field'] ) ) {
				$af_wc_daps_expected_date                    = isset( $_POST['af_wc_daps_expected_date_info_field'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_expected_date_info_field'] ) ) : '';
				$af_wc_daps_expected_date_data_checkout_page = array(
					'af_wc_daps_expected_date_info_checkout_page'       => $af_wc_daps_expected_date,
				);

				$order->update_meta_data( 'af_wc_daps_expected_date_data_checkout_page', $af_wc_daps_expected_date_data_checkout_page );
			}

			if ( isset( $_POST['af_wc_daps_enable_checkout_page'] ) || isset( $_POST['af_wc_daps_date_checkout_page'] ) || isset( $_POST['af_wc_daps_time_checkout_page'] ) || isset( $_POST['af_wc_daps_time_slot_select_checkout_page'] )  || isset( $_POST['af_wc_daps_week_day_fee_checkout_page'] ) ) {

				$af_wc_daps_enable_checkout_page = isset( $_POST['af_wc_daps_enable_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_enable_checkout_page'] ) ) : '';

				$af_wc_daps_rule_id_checkout_page = isset( $_POST['af_wc_daps_rule_id_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_rule_id_checkout_page'] ) ) : '';

				$af_wc_daps_date_checkout_page = isset( $_POST['af_wc_daps_date_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_date_checkout_page'] ) ) : '';

				$af_wc_daps_time_checkout_page = isset( $_POST['af_wc_daps_time_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_time_checkout_page'] ) ) : '';

				if ('' != $af_wc_daps_time_checkout_page) {
					$af_wc_daps_time_checkout_page = explode('_', $af_wc_daps_time_checkout_page);
	
					$timeslot_key                  = $af_wc_daps_time_checkout_page[0];
					$af_wc_daps_time_checkout_page = $af_wc_daps_time_checkout_page[1];

				}
				
				$af_wc_daps_time_slot_select_checkout_page = isset( $_POST['af_wc_daps_time_slot_select_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_time_slot_select_checkout_page'] ) ) : '';

				if ('' != $af_wc_daps_time_slot_select_checkout_page) {
					$af_wc_daps_time_slot_select_checkout_page = explode('_', $af_wc_daps_time_slot_select_checkout_page);
	
					$timeslot_key                              = $af_wc_daps_time_slot_select_checkout_page[0];
					$af_wc_daps_time_slot_select_checkout_page = $af_wc_daps_time_slot_select_checkout_page[1];

				}

				$af_wc_daps_rule_week_day_fee_checkout_page = isset( $_POST['af_wc_daps_week_day_fee_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_week_day_fee_checkout_page'] ) ) : '';

				$af_wc_daps_selected_day_fee     = 0;
				$af_wc_daps_specific_day_charges = 0;
				$af_wc_daps_only_day_fee         = 0;

				if ( '' != $af_wc_daps_date_checkout_page ) {

					$af_wc_daps_time_stamp = strtotime( $af_wc_daps_date_checkout_page );

					$af_wc_daps_day_name = gmdate( 'l', $af_wc_daps_time_stamp );

					$af_wc_daps_day_map = array(
						'Monday'    => 0,
						'Tuesday'   => 1,
						'Wednesday' => 2,
						'Thursday'  => 3,
						'Friday'    => 4,
						'Saturday'  => 5,
						'Sunday'    => 6,
					);

					$af_wc_daps_day_number = $af_wc_daps_day_map[ $af_wc_daps_day_name ];

					$af_wc_daps_values = explode( ',', $af_wc_daps_rule_week_day_fee_checkout_page );

					$af_wc_daps_only_day_fee = $af_wc_daps_selected_day_fee;

					if ( isset( $af_wc_daps_values[ $af_wc_daps_day_number ] ) ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_values[ $af_wc_daps_day_number ];
						$af_wc_daps_only_day_fee     = $af_wc_daps_selected_day_fee;
					}

					if ( '' != $af_wc_daps_time_slot_select_checkout_page ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_selected_day_fee + af_wc_daps_extract_time_slot_fee( $af_wc_daps_time_slot_select_checkout_page );
					}


					$af_wc_daps_special_days_details = af_wc_daps_get_remaining_orders_and_charges_of_all_sepecific_days();

					foreach ($af_wc_daps_special_days_details as $specific_day_setting) {
						if (DateTime::createFromFormat( 'F j, Y', $specific_day_setting['af_wc_daps_date'] ) == DateTime::createFromFormat( 'F j, Y', $af_wc_daps_date_checkout_page )) {
							$af_wc_daps_specific_day_charges = isset($specific_day_setting['af_wc_daps_specific_day_charges'])?$specific_day_setting['af_wc_daps_specific_day_charges']:0;
							break;
						}
					}

					
					$af_wc_daps_selected_day_fee += $af_wc_daps_specific_day_charges;

					$af_wc_daps_only_day_fee += $af_wc_daps_specific_day_charges;

					$applied_time_slot_details_checkout_page = '';
					if ('' != $af_wc_daps_time_slot_select_checkout_page) {
						$applied_time_slot_details_checkout_page = $af_wc_daps_rule_id_checkout_page . '_' . $timeslot_key;
					}

					if ('' != $af_wc_daps_time_checkout_page) {
						$applied_time_slot_details_checkout_page = $af_wc_daps_rule_id_checkout_page . '_' . $timeslot_key;
					}
					


				}

				$af_wc_daps_order_data_checkout_page = array(
					'af_wc_daps_enable_checkout_page' => $af_wc_daps_enable_checkout_page,
					'af_wc_daps_date_checkout_page'   => $af_wc_daps_date_checkout_page,
					'af_wc_daps_time_checkout_page'   => $af_wc_daps_time_checkout_page,
					'af_wc_daps_time_slot_select_checkout_page' => $af_wc_daps_time_slot_select_checkout_page,
					'af_wc_daps_only_day_fee'         => $af_wc_daps_only_day_fee,
					'af_wc_daps_rule_week_day_fee_checkout_page' => $af_wc_daps_selected_day_fee,
					'applied_time_slot_details_checkout_page' => $applied_time_slot_details_checkout_page,

				);

				$order->update_meta_data( 'af_wc_daps_order_data_checkout_page', $af_wc_daps_order_data_checkout_page );
			}
		}
		
		public function af_wc_daps_save_delivery_info_data_to_order_meta_data_blocks( $order ) {

			$af_wc_daps_expected_date_info_field =  WC()->session->get( 'af_wc_daps_rule_data');

			if ( isset( $af_wc_daps_expected_date_info_field['selection_mode']) && 'expected_date' == $af_wc_daps_expected_date_info_field['selection_mode'] ) {
			
				$af_wc_daps_expected_date_data_checkout_page = array(
					'af_wc_daps_expected_date_info_checkout_page'       => $af_wc_daps_expected_date_info_field['rule_data'],
				);

				$order->update_meta_data( 'af_wc_daps_expected_date_data_checkout_page', $af_wc_daps_expected_date_data_checkout_page );
			}

			$af_wc_daps_calendar_field =  WC()->session->get( 'af_wc_daps_checkout_page_delivery_data');

			if ( isset( $af_wc_daps_calendar_field['date'] ) && isset($af_wc_daps_calendar_field['timeSelectionType']) && isset( $af_wc_daps_calendar_field['timeSlot'] ) && isset( $af_wc_daps_calendar_field['ruleId'] ) && isset( $af_wc_daps_calendar_field['dayFee'] )  ) {

				$af_wc_daps_date_checkout_page = $af_wc_daps_calendar_field['date'];

				$af_wc_daps_rule_id_checkout_page = $af_wc_daps_calendar_field['ruleId'];

				$af_wc_daps_time_slot_select_checkout_page = '';
				$af_wc_daps_time_checkout_page             = ''; 

				if ('time_slot' == $af_wc_daps_calendar_field['timeSelectionType']) {
					$af_wc_daps_time_slot_select_checkout_page = $af_wc_daps_calendar_field['timeSlot'];
				} elseif ('time_select' == $af_wc_daps_calendar_field['timeSelectionType']) {
					$af_wc_daps_time_checkout_page = $af_wc_daps_calendar_field['timeSlot'];
				}

				$af_wc_daps_rule_week_day_fee_checkout_page = $af_wc_daps_calendar_field['dayFee'];
				
				if ('' != $af_wc_daps_time_checkout_page) {
					$af_wc_daps_time_checkout_page = explode('_', $af_wc_daps_time_checkout_page);
	
					$timeslot_key                  = $af_wc_daps_time_checkout_page[0];
					$af_wc_daps_time_checkout_page = $af_wc_daps_time_checkout_page[1];

				}
				
				if ('' != $af_wc_daps_time_slot_select_checkout_page) {
					$af_wc_daps_time_slot_select_checkout_page = explode('_', $af_wc_daps_time_slot_select_checkout_page);
	
					$timeslot_key                              = $af_wc_daps_time_slot_select_checkout_page[0];
					$af_wc_daps_time_slot_select_checkout_page = $af_wc_daps_time_slot_select_checkout_page[1];

				}

				$af_wc_daps_rule_week_day_fee_checkout_page = $af_wc_daps_calendar_field['dayFee'];

				$af_wc_daps_selected_day_fee     = 0;
				$af_wc_daps_specific_day_charges = 0;
				$af_wc_daps_only_day_fee         = 0;

				if ( '' != $af_wc_daps_date_checkout_page ) {

					$af_wc_daps_time_stamp = strtotime( $af_wc_daps_date_checkout_page );

					$af_wc_daps_day_name = gmdate( 'l', $af_wc_daps_time_stamp );

					$af_wc_daps_day_map = array(
						'Monday'    => 0,
						'Tuesday'   => 1,
						'Wednesday' => 2,
						'Thursday'  => 3,
						'Friday'    => 4,
						'Saturday'  => 5,
						'Sunday'    => 6,
					);

					$af_wc_daps_day_number = $af_wc_daps_day_map[ $af_wc_daps_day_name ];

					$af_wc_daps_values = explode( ',', $af_wc_daps_rule_week_day_fee_checkout_page );

					$af_wc_daps_only_day_fee = $af_wc_daps_selected_day_fee;

					if ( isset( $af_wc_daps_values[ $af_wc_daps_day_number ] ) ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_values[ $af_wc_daps_day_number ];
						$af_wc_daps_only_day_fee     = $af_wc_daps_selected_day_fee;
					}

					if ( '' != $af_wc_daps_time_slot_select_checkout_page ) {
						$af_wc_daps_selected_day_fee = $af_wc_daps_selected_day_fee + af_wc_daps_extract_time_slot_fee( $af_wc_daps_time_slot_select_checkout_page );
					}


					$af_wc_daps_special_days_details = af_wc_daps_get_remaining_orders_and_charges_of_all_sepecific_days();

					foreach ($af_wc_daps_special_days_details as $specific_day_setting) {
						if (DateTime::createFromFormat( 'F j, Y', $specific_day_setting['af_wc_daps_date'] ) == DateTime::createFromFormat( 'F j, Y', $af_wc_daps_date_checkout_page )) {
							$af_wc_daps_specific_day_charges = isset($specific_day_setting['af_wc_daps_specific_day_charges'])?$specific_day_setting['af_wc_daps_specific_day_charges']:0;
							break;
						}
					}

					
					$af_wc_daps_selected_day_fee += $af_wc_daps_specific_day_charges;

					$af_wc_daps_only_day_fee += $af_wc_daps_specific_day_charges;

					$applied_time_slot_details_checkout_page = '';
					if ('' != $af_wc_daps_time_slot_select_checkout_page) {
						$applied_time_slot_details_checkout_page = $af_wc_daps_rule_id_checkout_page . '_' . $timeslot_key;
					}

					if ('' != $af_wc_daps_time_checkout_page) {
						$applied_time_slot_details_checkout_page = $af_wc_daps_rule_id_checkout_page . '_' . $timeslot_key;
					}
					


				}

				$af_wc_daps_order_data_checkout_page = array(
					'af_wc_daps_enable_checkout_page' => 'on',
					'af_wc_daps_date_checkout_page'   => $af_wc_daps_date_checkout_page,
					'af_wc_daps_time_checkout_page'   => $af_wc_daps_time_checkout_page,
					'af_wc_daps_time_slot_select_checkout_page' => $af_wc_daps_time_slot_select_checkout_page,
					'af_wc_daps_only_day_fee'         => $af_wc_daps_only_day_fee,
					'af_wc_daps_rule_week_day_fee_checkout_page' => $af_wc_daps_selected_day_fee,
					'applied_time_slot_details_checkout_page' => $applied_time_slot_details_checkout_page,
				);

				$order->update_meta_data( 'af_wc_daps_order_data_checkout_page', $af_wc_daps_order_data_checkout_page );
			}
		}

		public function af_wc_daps_display_delivery_info_data_for_whole_order( $order ) {

			$af_wc_daps_order_data                       =  $order->get_meta('af_wc_daps_order_data_checkout_page');
			$af_wc_daps_expected_date_data_checkout_page =  (array) $order->get_meta('af_wc_daps_expected_date_data_checkout_page');

			$af_wc_daps_expected_info_style_settings = (array) get_option( 'af_wc_daps_expected_info_style_settings' );

			$enable_icon = isset( $af_wc_daps_expected_info_style_settings['af_wc_daps_enable_icon_for_expected_date_info'] ) ? $af_wc_daps_expected_info_style_settings['af_wc_daps_enable_icon_for_expected_date_info'] : '';
			$icon_url    = isset( $af_wc_daps_expected_info_style_settings['af_wc_daps_icon_for_expected_date_info'] ) ? $af_wc_daps_expected_info_style_settings['af_wc_daps_icon_for_expected_date_info'] : '';
			$image_width = isset( $af_wc_daps_expected_info_style_settings['af_wc_daps_icon_width_expected_date_info'] ) && '' != $af_wc_daps_expected_info_style_settings['af_wc_daps_icon_width_expected_date_info'] ? $af_wc_daps_expected_info_style_settings['af_wc_daps_icon_width_expected_date_info'] : '42';
			$bg_color    = isset( $af_wc_daps_expected_info_style_settings['af_wc_daps_bg_color_of_expected_date_container'] ) ? $af_wc_daps_expected_info_style_settings['af_wc_daps_bg_color_of_expected_date_container'] : '#EFF3F5';
			$text_color  = isset( $af_wc_daps_expected_info_style_settings['af_wc_daps_text_color_of_expected_date_container'] ) ? $af_wc_daps_expected_info_style_settings['af_wc_daps_text_color_of_expected_date_container'] : '#6d6d6d';

			if ('' == $icon_url) {
				$icon_url = AF_WC_DAPS_PLUGIN_URL . '/assets/img/truck.png';
			}

			?>
				<style>
					.af-wc-daps-expected-info-div{
						background-color: <?php echo esc_attr($bg_color); ?>;
						color: <?php echo esc_attr($text_color); ?>
					}
					.af-wc-daps-expected-info-icon {
						width: <?php echo esc_attr($image_width) . 'px'; ?>;
						height: <?php echo esc_attr($image_width) . 'px'; ?>;
						display: inline-block;
						background-size: contain; 
						background-repeat: no-repeat; 
						background-position: center; 
					}

				</style>
			<?php

			if ( ! empty( $af_wc_daps_order_data ) ) {

				echo '<br>';
				echo "<table class='af-wc-daps-delivery-info-table-order-edit-page'>";

				foreach ( $af_wc_daps_order_data as $key => $value ) {

					$key = af_wc_daps_formatted_key_names( $key );
					
					if ( ( 'Total Fee' == $key || 'Day Fee' == $key ) && 0 == $value ) {
						continue;
					}
					if ( '' != $value ) {
						$af_wc_daps_rule_applied_on_this_order = true;
						if ('af_wc_daps_enable_checkout_page' == $key || 'af_wc_daps_single_product_page_enable' == $key || 'applied_time_slot_details_checkout_page' == $key ) {
							continue;
						}
						if ( 'Total Fee' == $key || 'Day Fee' == $key ) {
							echo '<tr>';
							echo '<td>';
							echo '<label><b>' . esc_attr($key) . ':</b></label>';
							echo '</td>';
							echo "<td style='width:1%'></td>";
							echo '<td>';
							echo wp_kses_post(wc_price($value));
							echo '</td>';
							echo '</tr>';
							continue;
						}
							echo '<tr>';
							echo '<td>';
							echo '<label><b>' . esc_attr( $key ) . ':</b></label>';
							echo '</td>';
							echo "<td style='width:1%'></td>";
							echo '<td>';
							echo esc_attr( $value );
							echo '</td>';
							echo '</tr>';
					}
				}
				echo '</table>';
			}

			if ( ! empty( $af_wc_daps_expected_date_data_checkout_page ) ) {
				foreach ( $af_wc_daps_expected_date_data_checkout_page as $key => $value ) {
					if ( '' != $value ) {
						?>
						<div class="af-wc-daps-expected-info-div">
							<?php
							if ('' != $enable_icon) {
								?>
								<span class="af-wc-daps-expected-info-icon" style="background-image: url('<?php echo esc_url( $icon_url ); ?>');"></span>							
							<?php
							}
							?>
							<span class="af-wc-daps-expected-info-message">
								<?php echo wp_kses_post( $value ); ?>
						</div>

						<?php
					}
				}
			}
		}

		public function af_wc_daps_insert_order_delivery_info_table( $order_id ) {

			if (get_option('af_wc_daps_order_data_updated_' . $order_id) == 'yes') {
			return;
			} else {
			update_option('af_wc_daps_order_data_updated_' . $order_id, 'yes');
			}

			WC()->session->set( 'af_wc_daps_rule_data', array() );
			WC()->session->set( 'af_wc_daps_checkout_page_delivery_data', array() );

			$order = wc_get_order($order_id);

			$af_wc_daps_rule_applied_on_this_order    = false;
			$af_wc_daps_rule_applied_on_product_level = false;

			$af_wc_daps_order_data                       =  $order->get_meta('af_wc_daps_order_data_checkout_page')?$order->get_meta('af_wc_daps_order_data_checkout_page'):array();
			$af_wc_daps_expected_date_data_checkout_page =  $order->get_meta('af_wc_daps_expected_date_data_checkout_page')?$order->get_meta('af_wc_daps_expected_date_data_checkout_page'):array();


			if (( $af_wc_daps_order_data && isset($af_wc_daps_order_data['af_wc_daps_enable_checkout_page']) && 'on' == $af_wc_daps_order_data['af_wc_daps_enable_checkout_page'] )  || ( $af_wc_daps_expected_date_data_checkout_page && isset($af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page']) && '' != $af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page'] )) {
				$af_wc_daps_rule_applied_on_this_order = true;  
			}
		
			foreach ( $order->get_items() as $item_id => $item ) {

				$af_wc_daps_delivery_info = $item->get_meta( 'af_wc_daps_delivery_info_data', true );
				$af_wc_daps_expected_date = $item->get_meta( 'af_wc_daps_expected_date_data', true );

				if ( ( ! empty( $af_wc_daps_delivery_info ) ) || ! empty( $af_wc_daps_expected_date ) ) {
					$af_wc_daps_rule_applied_on_product_level = true;
					break;
				}
			}   

			$already_passed_slot             = array();
			$already_passed_time_select_slot = array();

			//for product level delivery date 
			if ($af_wc_daps_rule_applied_on_product_level) {
				foreach ( $order->get_items() as $item_id => $item ) {
					
					$af_wc_daps_delivery_info = $item->get_meta( 'af_wc_daps_delivery_info_data', true );

					$af_wc_daps_applied_time_selector_slot = isset($af_wc_daps_delivery_info['af_wc_daps_time_for_single_product']) && '' != $af_wc_daps_delivery_info['af_wc_daps_time_for_single_product'] ? $af_wc_daps_delivery_info['af_wc_daps_time_for_single_product'] :'';
					$af_wc_daps_applied_time_slot          = isset($af_wc_daps_delivery_info['af_wc_daps_time_slot_select']) && '' != $af_wc_daps_delivery_info['af_wc_daps_time_slot_select'] ? $af_wc_daps_delivery_info['af_wc_daps_time_slot_select']:'';
					$af_wc_daps_single_product_page_date   = isset($af_wc_daps_delivery_info['af_wc_daps_single_product_page_date'])?$af_wc_daps_delivery_info['af_wc_daps_single_product_page_date']:'';


					$applied_time_slot_details = isset($af_wc_daps_delivery_info['applied_time_slot_details']) && '' != $af_wc_daps_delivery_info['applied_time_slot_details'] ? $af_wc_daps_delivery_info['applied_time_slot_details'] :'';


					if ('' != $af_wc_daps_single_product_page_date) {
						$af_wc_daps_single_product_page_date = DateTime::createFromFormat('F j, Y', $af_wc_daps_single_product_page_date)->format('Y-m-d');
					}

					//rule matching
					if ('' == $af_wc_daps_applied_time_selector_slot && '' == $af_wc_daps_applied_time_slot) {
						continue;
					} elseif ('' != $af_wc_daps_applied_time_selector_slot) {

						$applied_time_slot_details = explode('_', $applied_time_slot_details);
	
						$rule_id      = $applied_time_slot_details[0];
						$timeslot_key = $applied_time_slot_details[1];

						$key_for_rule_settings = $af_wc_daps_single_product_page_date . '_' . $rule_id . '_' . $timeslot_key;

						if (empty($already_passed_time_select_slot)) {
							
							$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);
							$rule_settings = '' != $rule_settings ? $rule_settings:array();

							$time_select_settings = get_post_meta($rule_id, 'af_wc_daps_rule_settings', true);

							$remaining = isset($time_select_settings['orders_per_slot']) && '' != $time_select_settings['orders_per_slot']?$time_select_settings['orders_per_slot']:'';

							//no restriction on orders restriction
							if ('' == $remaining) {
								continue;
							}

							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}

								update_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', $rule_settings);
								$already_passed_time_select_slot[] = $key_for_rule_settings;
								continue;
							}   
						} elseif (!in_array($key_for_rule_settings, $already_passed_time_select_slot)) {

								$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);
								$rule_settings = '' != $rule_settings ? $rule_settings:array();

								$time_select_settings = get_post_meta($rule_id, 'af_wc_daps_rule_settings', true);

								$remaining =isset($time_select_settings['orders_per_slot']) && '' != $time_select_settings['orders_per_slot']?$time_select_settings['orders_per_slot']:'';
									
							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}
									update_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', $rule_settings);
									$already_passed_time_select_slot[] = $key_for_rule_settings;
									continue;
							}   
						}
					} elseif ('' != $af_wc_daps_applied_time_slot) {   
						
						$applied_time_slot_details = explode('_', $applied_time_slot_details);
	
						$rule_id      = $applied_time_slot_details[0];
						$timeslot_key = $applied_time_slot_details[1];

						$key_for_rule_settings = $af_wc_daps_single_product_page_date . '_' . $rule_id . '_' . $timeslot_key;


						if (empty($already_passed_slot)) {
							
							$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', true);
							$rule_settings = '' != $rule_settings ? $rule_settings:array();

							$time_slot_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_settings', true);

							$remaining = isset($time_slot_settings[ $timeslot_key ]['orders_per_slot'])?$time_slot_settings[ $timeslot_key ]['orders_per_slot']:'';


							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}

								update_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', $rule_settings);
								$already_passed_slot[] = $key_for_rule_settings;
								continue;

							}
							
						} elseif (!in_array($key_for_rule_settings, $already_passed_slot)) {

								$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', true);
								$rule_settings = '' != $rule_settings ? $rule_settings:array();

								$time_slot_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_settings', true);
	
								$remaining = isset($time_slot_settings[ $timeslot_key ]['orders_per_slot'])?$time_slot_settings[ $timeslot_key ]['orders_per_slot']:'';
								
							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}
									update_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', $rule_settings);
									$already_passed_slot[] = $key_for_rule_settings;
									continue;
							}   
						}
					}

				}
			}
			
			//for order level delivery date(checkout page)
			if ($af_wc_daps_rule_applied_on_this_order) {
				if (!empty($af_wc_daps_order_data)) {

					$af_wc_daps_applied_time_slot        = isset($af_wc_daps_order_data['af_wc_daps_time_slot_select_checkout_page']) && '' != $af_wc_daps_order_data['af_wc_daps_time_slot_select_checkout_page']?$af_wc_daps_order_data['af_wc_daps_time_slot_select_checkout_page']:'';
					$af_wc_daps_applied_time_select_slot = isset($af_wc_daps_order_data['af_wc_daps_time_checkout_page']) && '' != $af_wc_daps_order_data['af_wc_daps_time_checkout_page']?$af_wc_daps_order_data['af_wc_daps_time_checkout_page']:'';

					$af_wc_daps_date_checkout_page = isset($af_wc_daps_order_data['af_wc_daps_date_checkout_page'])?$af_wc_daps_order_data['af_wc_daps_date_checkout_page']:'';

					$applied_time_slot_details = isset($af_wc_daps_order_data['applied_time_slot_details_checkout_page']) && '' != $af_wc_daps_order_data['applied_time_slot_details_checkout_page'] ? $af_wc_daps_order_data['applied_time_slot_details_checkout_page'] :'';


					if ('' != $af_wc_daps_date_checkout_page) {
						$af_wc_daps_date_checkout_page = DateTime::createFromFormat('F j, Y', $af_wc_daps_date_checkout_page)->format('Y-m-d');
					}
					
					if ('' != $af_wc_daps_applied_time_slot) {
						$applied_time_slot_details = explode('_', $applied_time_slot_details);

						$rule_id      = $applied_time_slot_details[0];
						$timeslot_key = $applied_time_slot_details[1];

						$key_for_rule_settings = $af_wc_daps_date_checkout_page . '_' . $rule_id . '_' . $timeslot_key;


						if (empty($already_passed_slot)) {
							
							$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', true);
							$rule_settings = '' != $rule_settings ? $rule_settings:array();

							$time_slot_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_settings', true);

							$remaining = isset($time_slot_settings[ $timeslot_key ]['orders_per_slot'])?$time_slot_settings[ $timeslot_key ]['orders_per_slot']:'';


							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}

								update_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', $rule_settings);
								$already_passed_slot[] = $key_for_rule_settings;

							}

							
							
						} elseif (!in_array($key_for_rule_settings, $already_passed_slot)) {

								$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', true);
								$rule_settings = '' != $rule_settings ? $rule_settings:array();

								$time_slot_settings = get_post_meta($rule_id, 'af_wc_daps_time_slot_settings', true);

								$remaining = isset($time_slot_settings[ $timeslot_key ]['orders_per_slot'])?$time_slot_settings[ $timeslot_key ]['orders_per_slot']:'';
								
							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}
									update_post_meta($rule_id, 'af_wc_daps_time_slot_per_order_details', $rule_settings);
									$already_passed_slot[] = $key_for_rule_settings;
							}
							
						}
	
						
					} elseif ('' != $af_wc_daps_applied_time_select_slot) {

						$applied_time_slot_details = explode('_', $applied_time_slot_details);

						$rule_id      = $applied_time_slot_details[0];
						$timeslot_key = $applied_time_slot_details[1];

						$key_for_rule_settings = $af_wc_daps_date_checkout_page . '_' . $rule_id . '_' . $timeslot_key;


						if (empty($already_passed_time_select_slot)) {
							
							$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);
							$rule_settings = '' != $rule_settings ? $rule_settings:array();

							$time_select_settings = get_post_meta($rule_id, 'af_wc_daps_rule_settings', true);
							
							$remaining = isset($time_select_settings['orders_per_slot']) && '' != $time_select_settings['orders_per_slot']?$time_select_settings['orders_per_slot']:'';


							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}

								update_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', $rule_settings);
								$already_passed_time_select_slot[] = $key_for_rule_settings;

							}

							
							
						} elseif (!in_array($key_for_rule_settings, $already_passed_time_select_slot)) {

								$rule_settings = get_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', true);
								$rule_settings = '' != $rule_settings ? $rule_settings:array();

								$time_select_settings = get_post_meta($rule_id, 'af_wc_daps_rule_settings', true);
							
								$remaining = isset($time_select_settings['orders_per_slot']) && '' != $time_select_settings['orders_per_slot']? $time_select_settings['orders_per_slot']:'';

								
							if ('' != $remaining) {
								if (empty($rule_settings)) {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								} elseif (in_array($key_for_rule_settings, array_keys($rule_settings))) {
										$rule_settings[ $key_for_rule_settings ] =$rule_settings[ $key_for_rule_settings ] -1;
								} else {
									$rule_settings[ $key_for_rule_settings ] =  $remaining-1;
								}
									update_post_meta($rule_id, 'af_wc_daps_time_select_slot_per_order_details', $rule_settings);
									$already_passed_time_select_slot[] = $key_for_rule_settings;
							}
							
						}
					}

					
										
						
				}
			}

			
			$af_wc_daps_special_days = af_wc_daps_get_all_specific_days();

			$af_wc_daps_customer_details = $order->get_customer_id();

			$af_wc_daps_first_name = $order->get_billing_first_name();
			$af_wc_daps_last_name  = $order->get_billing_last_name();
			$af_wc_daps_email      = $order->get_billing_email();

			$af_wc_daps_customer_details = $af_wc_daps_first_name . ' ' . $af_wc_daps_last_name . '(' . $af_wc_daps_email . ')';

			if ( $af_wc_daps_rule_applied_on_this_order ) {

				$af_wc_daps_products_without_separate_delivery_info                = array();
				$af_wc_daps_products_with_delivery_info_set_at_single_product_page = array();

				foreach ( $order->get_items() as $item_id => $item ) {
					$af_wc_daps_product_name       = $item->get_name();
					$af_wc_daps_product_id         = $item->get_product_id();
					$af_wc_daps_quantity           = $item->get_quantity();
					$af_wc_daps_delivery_info      = $item->get_meta( 'af_wc_daps_delivery_info_data', true );
					$af_wc_daps_expected_date_info = (array) $item->get_meta( 'af_wc_daps_expected_date_data', true );
					$af_wc_daps_expected_date      = isset( $af_wc_daps_expected_date_info['af_wc_daps_expected_date_info'] ) ? $af_wc_daps_expected_date_info['af_wc_daps_expected_date_info'] : '';


					if ( ( empty( $af_wc_daps_delivery_info ) || ! isset( $af_wc_daps_delivery_info['af_wc_daps_single_product_page_enable'] ) || '' == $af_wc_daps_delivery_info['af_wc_daps_single_product_page_enable'] ) && empty( $af_wc_daps_expected_date ) ) {
						$af_wc_daps_products_without_separate_delivery_info [] = array(
							'af_wc_daps_product_id' => $af_wc_daps_product_id,
							'af_wc_daps_product'    => $af_wc_daps_product_name . ' x ' . $af_wc_daps_quantity,
						);
					}
				}

				if ( ! empty( $af_wc_daps_products_without_separate_delivery_info ) ) {

					$af_wc_daps_expected_date_info              = isset( $af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page'] ) ? $af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page'] : '';
					$af_wc_daps_selection_method                = isset( $af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page'] ) && '' != $af_wc_daps_expected_date_data_checkout_page['af_wc_daps_expected_date_info_checkout_page'] ? 'Expected Date' : 'Calendar';
					$af_wc_daps_order_date                      = isset( $af_wc_daps_order_data['af_wc_daps_date_checkout_page'] ) ? $af_wc_daps_order_data['af_wc_daps_date_checkout_page'] : '';
					$af_wc_daps_time                            = isset( $af_wc_daps_order_data['af_wc_daps_time_checkout_page'] ) ? $af_wc_daps_order_data['af_wc_daps_time_checkout_page'] : '';
					$af_wc_daps_time_slot_select_checkout_page  = isset( $af_wc_daps_order_data['af_wc_daps_time_slot_select_checkout_page'] ) ? $af_wc_daps_order_data['af_wc_daps_time_slot_select_checkout_page'] : '';
					$af_wc_daps_rule_week_day_fee_checkout_page = isset( $af_wc_daps_order_data['af_wc_daps_rule_week_day_fee_checkout_page'] ) ? $af_wc_daps_order_data['af_wc_daps_rule_week_day_fee_checkout_page'] : '0';

					$af_wc_daps_new_order_delivery_post = array(
						'post_status' => 'publish',
						'post_type'   => 'daps_order_delivery',
					);

					$post = wp_insert_post( $af_wc_daps_new_order_delivery_post );

					$af_wc_daps_order_delivery_info = array(
						'af_wc_daps_order_id'           => $order_id,
						'af_wc_daps_user_details'       => $af_wc_daps_customer_details,
						'af_wc_daps_products'           => $af_wc_daps_products_without_separate_delivery_info,
						'af_wc_daps_delivery_date'      => $af_wc_daps_order_date,
						'af_wc_daps_selection_method'   => $af_wc_daps_selection_method,
						'af_wc_daps_expected_date_info' => $af_wc_daps_expected_date_info,
						'af_wc_daps_time_slots'         => $af_wc_daps_time . '' . $af_wc_daps_time_slot_select_checkout_page,
						'af_wc_daps_delivery_fee'       => $af_wc_daps_rule_week_day_fee_checkout_page,
					);

					update_post_meta( $post, 'af_wc_daps_order_delivery_info', $af_wc_daps_order_delivery_info );
				}
			}

			if ( $af_wc_daps_rule_applied_on_product_level ) {

				foreach ( $order->get_items() as $item_id => $item ) {
					$af_wc_daps_product_name       = $item->get_name();
					$af_wc_daps_product_id         = $item->get_product_id();
					$af_wc_daps_quantity           = $item->get_quantity();
					$af_wc_daps_delivery_info      = $item->get_meta( 'af_wc_daps_delivery_info_data', true );
					$af_wc_daps_expected_date_info = $item->get_meta( 'af_wc_daps_expected_date_data', true );
					$af_wc_daps_expected_date      = isset( $af_wc_daps_expected_date_info['af_wc_daps_expected_date_info'] ) ? $af_wc_daps_expected_date_info['af_wc_daps_expected_date_info'] : '';

					if ( ( isset($af_wc_daps_delivery_info['af_wc_daps_single_product_page_enable']) && '' != $af_wc_daps_delivery_info['af_wc_daps_single_product_page_enable'] ) || '' != $af_wc_daps_expected_date  ) {

						// $af_wc_daps_new_product_delivery_post = array(
						//  'post_status'   => 'publish',
						//  'post_type'     => 'daps_prod_delivery',
						// );

						$af_wc_daps_new_product_delivery_post = array(
							'post_status' => 'publish',
							'post_type'   => 'daps_order_delivery',
						);

						$post = wp_insert_post( $af_wc_daps_new_product_delivery_post );


						$af_wc_daps_selection_method = '' != $af_wc_daps_expected_date ? 'Expected Date' : 'Calendar';

						$af_wc_daps_expected_date_info = $af_wc_daps_expected_date;

						$af_wc_daps_date              = isset( $af_wc_daps_delivery_info['af_wc_daps_single_product_page_date'] ) ? $af_wc_daps_delivery_info['af_wc_daps_single_product_page_date'] : '';
						$af_wc_daps_time              = isset( $af_wc_daps_delivery_info['af_wc_daps_time_for_single_product'] ) ? $af_wc_daps_delivery_info['af_wc_daps_time_for_single_product'] : '';
						$af_wc_daps_time_slot         = isset( $af_wc_daps_delivery_info['af_wc_daps_time_slot_select'] ) ? $af_wc_daps_delivery_info['af_wc_daps_time_slot_select'] : '';
						$af_wc_daps_rule_week_day_fee = isset( $af_wc_daps_delivery_info['af_wc_daps_rule_week_day_fee'] ) ? $af_wc_daps_delivery_info['af_wc_daps_rule_week_day_fee'] : '0';

						$product_name =array(
							'af_wc_daps_product_id' => $af_wc_daps_product_id,
							'af_wc_daps_product'    => $af_wc_daps_product_name . ' x ' . $af_wc_daps_quantity,
						);
					
						$af_wc_daps_order_delivery_info = array(
							'af_wc_daps_order_id'         => $order_id,
							'af_wc_daps_user_details'     => $af_wc_daps_customer_details,
							'af_wc_daps_products'         => array( $product_name ),
							'af_wc_daps_delivery_date'    => $af_wc_daps_date,
							'af_wc_daps_selection_method' => $af_wc_daps_selection_method,
							'af_wc_daps_expected_date_info' => $af_wc_daps_expected_date_info,
							'af_wc_daps_time_slots'       => $af_wc_daps_time . '' . $af_wc_daps_time_slot,
							'af_wc_daps_delivery_fee'     => $af_wc_daps_rule_week_day_fee,
						);
	
						update_post_meta( $post, 'af_wc_daps_order_delivery_info', $af_wc_daps_order_delivery_info );

					}
				}
			}

			if ( ! empty( $af_wc_daps_special_days ) && $af_wc_daps_rule_applied_on_this_order && isset( $af_wc_daps_order_data['af_wc_daps_date_checkout_page'] ) && '' != $af_wc_daps_order_data['af_wc_daps_date_checkout_page'] ) {
				foreach ( $af_wc_daps_special_days as $post_id ) {
					$af_wc_daps_specific_day_settings = (array) get_post_meta( $post_id, 'af_wc_daps_specific_day_settings', true );

					if ( isset( $af_wc_daps_specific_day_settings['af_wc_daps_specific_day_date'] ) ) {

						$af_wc_daps_order_date    = DateTime::createFromFormat( 'F j, Y', $af_wc_daps_order_data['af_wc_daps_date_checkout_page'] );
						$af_wc_daps_specific_date = DateTime::createFromFormat( 'F j, Y', $af_wc_daps_specific_day_settings['af_wc_daps_specific_day_date'] );
						if ( $af_wc_daps_order_date == $af_wc_daps_specific_date ) {
							$af_wc_daps_remaining_orders = get_post_meta( $post_id, 'af_wc_daps_remaining_orders_of_specific_day', true );
							if ( isset( $af_wc_daps_remaining_orders ) && '' != $af_wc_daps_remaining_orders && 0 != $af_wc_daps_remaining_orders ) {
								update_post_meta( $post_id, 'af_wc_daps_remaining_orders_of_specific_day', $af_wc_daps_remaining_orders - 1 );
							}
							break;

						}
					}
				}
			} elseif ( ! empty( $af_wc_daps_special_days ) && $af_wc_daps_rule_applied_on_product_level ) {
				$af_wc_daps_remaining_orders_updated = false;
				foreach ( $af_wc_daps_special_days as $post_id ) {
					$af_wc_daps_specific_day_settings = (array) get_post_meta( $post_id, 'af_wc_daps_specific_day_settings', true );

					if ( isset( $af_wc_daps_specific_day_settings['af_wc_daps_specific_day_date'] ) ) {

						foreach ( $order->get_items() as $item_id => $item ) {
							$af_wc_daps_delivery_info = $item->get_meta( 'af_wc_daps_delivery_info_data', true );
							$af_wc_daps_date          = isset( $af_wc_daps_delivery_info['af_wc_daps_single_product_page_date'] ) ? $af_wc_daps_delivery_info['af_wc_daps_single_product_page_date'] : '';
							if ('' == $af_wc_daps_date) {
								continue;
							}
							$af_wc_daps_order_date    = DateTime::createFromFormat( 'F j, Y', $af_wc_daps_date );
							$af_wc_daps_specific_date = DateTime::createFromFormat( 'F j, Y', $af_wc_daps_specific_day_settings['af_wc_daps_specific_day_date'] );

							if ( $af_wc_daps_order_date == $af_wc_daps_specific_date ) {
								$af_wc_daps_remaining_orders = get_post_meta( $post_id, 'af_wc_daps_remaining_orders_of_specific_day', true );
								if ( isset( $af_wc_daps_remaining_orders ) && '' != $af_wc_daps_remaining_orders && 0 != $af_wc_daps_remaining_orders ) {
									update_post_meta( $post_id, 'af_wc_daps_remaining_orders_of_specific_day', $af_wc_daps_remaining_orders - 1 );
								}
								$af_wc_daps_remaining_orders_updated = true;
								break;
	
							}

						}
						
					}
					if ($af_wc_daps_remaining_orders_updated) {
						break;
					}

				}
			}
		}

		public function af_wc_daps_add_to_cart_validation( $passed_validation, $product_id, $quantity, $variation_id = '', $variation = '' ) {

			$af_wc_daps_general_settings = get_option('af_wc_daps_general_settings');

			$af_wc_daps_mandatory_product_delivery_field = isset( $af_wc_daps_general_settings['af_wc_daps_mandatory_product_delivery_field'] ) ? true : false;

			$af_wc_daps_mandatory_product_timeslot_field = isset( $af_wc_daps_general_settings['af_wc_daps_mandatory_product_timeslot_field'] ) ? true : false;

			$af_wc_daps_label_settings = get_option('af_wc_daps_label_settings');

			$af_wc_daps_product_delivery_date_msg = isset($af_wc_daps_label_settings['af_wc_daps_product_delivery_date_msg']) && '' != $af_wc_daps_label_settings['af_wc_daps_product_delivery_date_msg']?$af_wc_daps_label_settings['af_wc_daps_product_delivery_date_msg']:'Please select a delivery date for {product_name}' ;       
			$af_wc_daps_product_timeslot_msg      = isset($af_wc_daps_label_settings['af_wc_daps_product_timeslot_msg']) && '' != $af_wc_daps_label_settings['af_wc_daps_product_timeslot_msg']?$af_wc_daps_label_settings['af_wc_daps_product_timeslot_msg']:'Please select a time slot for {product_name}' ;
			
			
			$nonce = isset( $_POST['af_wc_daps_nonce_field'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_nonce_field'] ) ) : '';
			
			if ( isset( $_POST['af_wc_daps_nonce_field'] ) && ! wp_verify_nonce( $nonce, 'af_wc_daps_nonce' ) ) {
				return false;
			}

			if ('' != $variation_id) {
				$product_id = $variation_id;
			}
			
		
			$product = wc_get_product($product_id);

			if ($product) {
				$product_name = $product->get_name();
			} else {
				$product_name = '';
			}
			
			$af_wc_daps_product_delivery_date_msg = str_replace('{product_name}', $product_name, $af_wc_daps_product_delivery_date_msg);
			$af_wc_daps_product_timeslot_msg      = str_replace('{product_name}', $product_name, $af_wc_daps_product_timeslot_msg);

			$is_rule_applied = false;


			$af_wc_daps_rule_settings = (array) get_post_meta( $product_id, 'af_wc_daps_rule_settings', true );

			if ( ! empty( $af_wc_daps_rule_settings ) && isset( $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) && 'yes' == $af_wc_daps_rule_settings['af_wc_daps_enable_rule'] ) {
				if ( 'expected_date' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
					return true;
				} elseif ('calendar' == $af_wc_daps_rule_settings['af_wc_daps_rule_delivery_selection_mode']) {
					$is_rule_applied = true;
					$rule_id         = $product_id;
				}
			}

			if (!$is_rule_applied) {
				$af_wc_daps_rule_posts = $this->af_wc_daps_get_all_rules();
	
				foreach ( $af_wc_daps_rule_posts as $post_id ) {
					if ( empty( $post_id ) ) {
						continue;
					}
	
					$is_product_match = false;
	
					$af_wc_daps_post_level_settings = (array) get_post_meta( $post_id, 'af_wc_daps_rule_settings', true );
	
	
					if ( empty( $af_wc_daps_post_level_settings ) ) {
						continue;
					}
	
					if ( ! isset( $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) || 'yes' != $af_wc_daps_post_level_settings['af_wc_daps_enable_rule'] ) {
						continue;
					}
	
					$af_wc_daps_product_ids_for_rule  = isset( $af_wc_daps_post_level_settings['af_wc_daps_product_ids_for_rule'] ) ? $af_wc_daps_post_level_settings['af_wc_daps_product_ids_for_rule'] : array();
					$af_wc_daps_selected_category_ids = isset( $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] ) ? $af_wc_daps_post_level_settings ['af_wc_daps_selected_category_ids'] : array();
	
					$product_categories = wp_get_post_terms( $product_id, 'product_cat', array( 'fields' => 'ids' ) );
	
					if ( empty( $af_wc_daps_product_ids_for_rule ) && empty( $af_wc_daps_selected_category_ids ) ) {
						$is_product_match = true;
					} elseif ( ! empty( $af_wc_daps_product_ids_for_rule ) && in_array( $product_id, $af_wc_daps_product_ids_for_rule ) ) {
						$is_product_match = true;
					} elseif ( ! empty( $af_wc_daps_selected_category_ids ) && ! empty( array_intersect( $product_categories, $af_wc_daps_selected_category_ids ) ) ) {
						$is_product_match = true;
					}
	
					if ( $is_product_match ) {
	
						if ( 'expected_date' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode'] ) {
							return true;
						} elseif ('calendar' == $af_wc_daps_post_level_settings['af_wc_daps_rule_delivery_selection_mode']) {
							$is_rule_applied = true;
							$rule_id         = $post_id;
							break;
						}
						
	
					}
				}

			}



			if ($is_rule_applied) {
				if ($af_wc_daps_mandatory_product_delivery_field && '' == $variation_id) {
					if (isset( $_POST['af_wc_daps_nonce_field'])) {
						if ( !isset($_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ]) || '' == $_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ]) {
							wc_add_notice($af_wc_daps_product_delivery_date_msg, 'error');
							return false;
						} 
					} else {
						wc_add_notice($af_wc_daps_product_delivery_date_msg, 'error');
						return false;
					}
				}

				$af_wc_daps_rule_settings = get_post_meta($rule_id , 'af_wc_daps_rule_settings', true);
				$time_selection_type      = isset($af_wc_daps_rule_settings['af_wc_daps_rule_time_selection_type'])?$af_wc_daps_rule_settings['af_wc_daps_rule_time_selection_type']:'none';


				if ($af_wc_daps_mandatory_product_timeslot_field) {
					if (isset( $_POST['af_wc_daps_nonce_field'])) {

						if ('time_slots' == $time_selection_type && isset($_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ]) && '' != $_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ] && ( !isset($_POST[ 'af_wc_daps_time_slot_select_' . $product_id ]) || '' == $_POST[ 'af_wc_daps_time_slot_select_' . $product_id ] )) {
							wc_add_notice($af_wc_daps_product_timeslot_msg, 'error');
							return false;
						}
						if ('time_selector' == $time_selection_type && isset($_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ]) && '' != $_POST[ 'af_wc_daps_single_product_page_date_' . $product_id ] && ( !isset($_POST[ 'af_wc_daps_time_for_single_product_' . $product_id ]) || '' == $_POST[ 'af_wc_daps_time_for_single_product_' . $product_id ] )) {
							wc_add_notice($af_wc_daps_product_timeslot_msg, 'error');
							return false;
						}
					}
				}
			}

			
			

			return $passed_validation;
		}

		public function af_wc_daps_place_order_validation() {

			$nonce = isset( $_POST['af_wc_daps_nonce_field'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_nonce_field'] ) ) : '';

			$af_wc_daps_general_setting = get_option('af_wc_daps_general_settings');

			$af_wc_daps_mandatory_order_delivery_field = isset( $af_wc_daps_general_setting['af_wc_daps_mandatory_order_delivery_field'] ) ? true : false;
			$af_wc_daps_mandatory_order_timeslot_field = isset( $af_wc_daps_general_setting['af_wc_daps_mandatory_order_timeslot_field'] ) ? true : false;

			$af_wc_daps_label_settings = get_option('af_wc_daps_label_settings');

			$af_wc_daps_order_delivery_date_msg = isset($af_wc_daps_label_settings['af_wc_daps_order_delivery_date_msg']) && '' != $af_wc_daps_label_settings['af_wc_daps_order_delivery_date_msg']?$af_wc_daps_label_settings['af_wc_daps_order_delivery_date_msg']:'Please select a delivery date' ;      
			$af_wc_daps_order_timeslot_msg      = isset($af_wc_daps_label_settings['af_wc_daps_order_timeslot_msg']) && '' != $af_wc_daps_label_settings['af_wc_daps_order_timeslot_msg']?$af_wc_daps_label_settings['af_wc_daps_order_timeslot_msg']:'Please select a time slot' ;
			

			if ( isset( $_POST['af_wc_daps_nonce_field'] ) && ! wp_verify_nonce( $nonce, 'af_wc_daps_nonce' ) ) {
				wc_add_notice(__('Security Check failed.', 'ka-order-delivery-date-and-time-scheduler'), 'error');
				die();
			}

			$af_wc_daps_rule_id_checkout_page = isset( $_POST['af_wc_daps_rule_id_checkout_page'] ) ? sanitize_text_field( wp_unslash( $_POST['af_wc_daps_rule_id_checkout_page'] ) ) : '';

			$af_wc_daps_rule_settings = get_post_meta($af_wc_daps_rule_id_checkout_page , 'af_wc_daps_rule_settings', true);
			$time_selection_type      = isset($af_wc_daps_rule_settings['af_wc_daps_rule_time_selection_type'])?$af_wc_daps_rule_settings['af_wc_daps_rule_time_selection_type']:'none';


			if ($af_wc_daps_mandatory_order_delivery_field && isset( $_POST['af_wc_daps_nonce_field'] )) {
				if (!isset( $_POST['af_wc_daps_enable_checkout_page'] ) ||  !isset($_POST['af_wc_daps_date_checkout_page']) || '' == $_POST['af_wc_daps_date_checkout_page'] ) {
					wc_add_notice($af_wc_daps_order_delivery_date_msg, 'error');
				}
			}

			if ($af_wc_daps_mandatory_order_timeslot_field && isset( $_POST['af_wc_daps_nonce_field'] )) {
				if ('time_slots' == $time_selection_type && isset($_POST['af_wc_daps_date_checkout_page']) && '' != $_POST['af_wc_daps_date_checkout_page'] && ( !isset($_POST['af_wc_daps_time_slot_select_checkout_page']) || '' == $_POST['af_wc_daps_time_slot_select_checkout_page'] )) {
					wc_add_notice($af_wc_daps_order_timeslot_msg, 'error');
					return false;
				}
				if ('time_selector' == $time_selection_type && isset($_POST['af_wc_daps_date_checkout_page']) && '' != $_POST['af_wc_daps_date_checkout_page'] && ( !isset($_POST['af_wc_daps_time_checkout_page']) || '' == $_POST['af_wc_daps_time_checkout_page'] )) {
					wc_add_notice($af_wc_daps_order_timeslot_msg, 'error');
					return false;
				}
				
			}
		}
	}

	new Af_Wc_Daps_Front();


}





